<?php
class jTweetsWidget extends WP_Widget
{
	
	function jTweetsWidget()
	{
		$widget_options = array(
			'classname'		=>	'jtweets-widget',
			'description'	=>	'A widget to show a fade-in/fade-out effect on Tweets using jQuery'
		);

		parent::WP_Widget(false, 'jTweets', $widget_options);
	}
	
	function widget($args, $instance)
	{
		extract($args, EXTR_SKIP );
		$title = ($instance['title']) ? $instance['title'] : 'jTweets Widget';
		$twitter_username = ($instance['twitter_username']) ? $instance['twitter_username'] : 'No Twitter Username Entered';
		$twitter_number = ($instance['twitter_number']) ? $instance['twitter_number'] : '3';
		$pixel_height = ($instance['pixel_height']) ? $instance['pixel_height'] : '0';
		$time_pause = $instance['time_pause']; // default is coming from jtweets.js

		echo $before_widget;
		echo $before_title . $title . $after_title;

		if ($twitter_username != 'No Twitter Username') {
			jtweets_echo($twitter_username, $twitter_number, $time_pause, $pixel_height);
		}
	}

	function form($instance)
	{
		?>

		<label for="<?php echo $this->get_field_id('title');?>">
			Title:<br />
			<input
				id="<?php echo $this->get_field_id('title');?>"
				name="<?php echo $this->get_field_name('title');?>"
				value="<?php echo esc_attr($instance['title']) ?>"
			/><br />
		</label>
		
		<label for="<?php echo $this->get_field_id('twitter_username');?>">
			Twitter Username:<br />
			<input
				id="<?php echo $this->get_field_id('twitter_username');?>"
				name="<?php echo $this->get_field_name('twitter_username');?>"
				value="<?php echo esc_attr($instance['twitter_username']) ?>"
			/><br />
		</label>

		<label for="<?php echo $this->get_field_id('twitter_number');?>">
			Number of Tweets:<br />
			<input
				id="<?php echo $this->get_field_id('twitter_number');?>"
				name="<?php echo $this->get_field_name('twitter_number');?>"
				value="<?php echo esc_attr($instance['twitter_number']) ?>"
				size="2" maxlength="2"
			/><br />
		</label>

		<label for="<?php echo $this->get_field_id('time_pause');?>">
			Time to pause (in milliseconds):<br />
			<input
				id="<?php echo $this->get_field_id('time_pause');?>"
				name="<?php echo $this->get_field_name('time_pause');?>"
				value="<?php echo esc_attr($instance['time_pause']) ?>"
				size="5" maxlength="5"
			/><br />
		</label>
		
		<label for="<?php echo $this->get_field_id('pixel_height');?>">
			Div Height in Pixels:<br />
			<input
				id="<?php echo $this->get_field_id('pixel_height');?>"
				name="<?php echo $this->get_field_name('pixel_height');?>"
				value="<?php echo esc_attr($instance['pixel_height']) ?>"
				size="3" maxlength="3"
			/><br />
		</label>
		
		<?php
	}
}