<?php
/*
Plugin Name: WP-jTweets
Plugin URI: http://www.sideways8.com/plugins/wp-jtweets
Description: A Widget that uses jQuery and Twitter to fade in and display a user's tweets one at a time, then fades into the next.
Version: 1.0.1
Author: Aaron Reimann
Author URI: http://sideways8.com
License: GPL3

Copyright 2011 Aaron Reimann aaron.reimann@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
include_once('class_widget.php');

##########
## inits
function jtweets_init()
{
	if (!is_admin()) {
		wp_enqueue_script('jtweets', WP_PLUGIN_URL . '/wp-jtweets/js/jtweets.js', array('jquery'));
	}
}
add_action('init', 'jtweets_init');

function jtweets_widget_init()
{
	register_widget("jTweetsWidget");
}
add_action('widgets_init', 'jtweets_widget_init');
##
##########

##########
## Adding jquery code in header
function jtweets_script_echo(){
	if (!is_admin()) { ?>
<script type="text/javascript">
jQuery(function() {
	$('#jtweets-feed').jTweetsFader();
});
</script>
<?php
	}
}
add_action('wp_print_scripts','jtweets_script_echo');
##
##########

##########
## Adding style sheet for front end
function jtweets_add_css() {
	if (!is_admin()) {
		wp_enqueue_style('wpf_css', plugins_url('/style.css', __FILE__) );
	}
}
add_action('wp_print_styles', 'jtweets_add_css');
##
##########


##########
## actual functions that spits out the code
function jtweets_twitter_formatter($date)
{

	$time = strftime("%s", strtotime($date));
	$twitter_time = human_time_diff($time, current_time('timestamp') ) . ' ago';
	return $twitter_time;
}

function jtweets_echo($twitter_username, $twitter_number, $time_pause, $pixel_height)
{
	include_once(ABSPATH.WPINC.'/rss.php');
	$feed = fetch_rss('http://twitter.com/statuses/user_timeline/'.$twitter_username.'.rss');
	$items = array_slice($feed->items, 0, $twitter_number);

// spitting out some JS.  probbly need to put this somewhere else, but maybe later.
?>
<script type="text/javascript">
jQuery(function() {
	jQuery('#jtweets-feed').jTweetsFader(<?php echo $time_pause; ?>);
});
</script>
<?php
	echo '<div id="jtweets-feed"';
		if (!empty($pixel_height)) { echo ' style="height: '.$pixel_height.'px;" '; }
	echo '>';

	foreach ($items as $item) :
		$description = $item['description'];
		$tweetdate = jtweets_twitter_formatter($item['pubdate']);
		$guid = $items->channel->item[$i]->guid;

		//remove username, colon, and single white space...
		$colon = ':';
		$positionColon = strpos($description, $colon);
		$description = substr_replace ($description, '', 0, ($positionColon +2));

		// remove http
		$http = 'http://';
		$http_pos = strpos  ($description, $http);

		if ($http_pos != NULL)
		{
			$linkLastChar = strlen ( $description );
			$linkLength = ($linkLastChar - $http_pos);
			$oldLink = substr ( $description , $http_pos , $linkLength );
			$newLink = '<a href="' . $oldLink . '">' . $oldLink . '</a>';
			$description = substr_replace  ( $description , $newLink , $http_pos , $linkLength );
		}

		echo '<li>';
			echo $description;
			echo ' <span>'.$tweetdate.'</span>';
		echo '</li>'."\r\n";
	endforeach;

	echo '</div>'."\r\n";
}
##
##########

?>
